Package java.util

## Class TimeZone

- java.lang.Object
- - java.util.TimeZone

- All Implemented Interfaces:
    `Serializable`, `Cloneable`

      public abstract class TimeZone
      extends Object
      implements Cloneable, Serializable

  `TimeZone` represents a time zone offset, and also figures out daylight savings.

  Typically, you get a `TimeZone` using `getDefault` which creates a `TimeZone` based on the time zone where the program is running. For example, for a program running in Japan, `getDefault` creates a `TimeZone` object based on Japanese Standard Time.

  You can also get a `TimeZone` using `getTimeZone` along with a time zone ID. For instance, the time zone ID for the U.S. Pacific Time zone is "America/Los_Angeles". So, you can get a U.S. Pacific Time `TimeZone` object with:

  >      TimeZone tz = TimeZone.getTimeZone("America/Los_Angeles");

  You can use the `getAvailableIDs` method to iterate through all the supported time zone IDs. You can then choose a supported ID to get a `TimeZone`. If the time zone you want is not represented by one of the supported IDs, then a custom time zone ID can be specified to produce a TimeZone. The syntax of a custom time zone ID is:

  >      CustomID:
  >              GMT Sign Hours : Minutes
  >              GMT Sign Hours Minutes
  >              GMT Sign Hours
  >      Sign: one of
  >              + -
  >      Hours:
  >              Digit
  >              Digit Digit
  >      Minutes:
  >              Digit Digit
  >      Digit: one of
  >              0 1 2 3 4 5 6 7 8 9

  Hours must be between 0 to 23 and Minutes must be between 00 to 59. For example, "GMT+10" and "GMT+0010" mean ten hours and ten minutes ahead of GMT, respectively.

  The format is locale independent and digits must be taken from the Basic Latin block of the Unicode standard. No daylight saving time transition schedule can be specified with a custom time zone ID. If the specified string doesn't match the syntax, `"GMT"` is used.

  When creating a `TimeZone`, the specified custom time zone ID is normalized in the following syntax:

  >      NormalizedCustomID:
  >              GMT Sign TwoDigitHours : Minutes
  >      Sign: one of
  >              + -
  >      TwoDigitHours:
  >              Digit Digit
  >      Minutes:
  >              Digit Digit
  >      Digit: one of
  >              0 1 2 3 4 5 6 7 8 9

  For example, TimeZone.getTimeZone("GMT-8").getID() returns "GMT-08:00".

  ### Three-letter time zone IDs

  See Also:
    `Calendar`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `LONG` | A style specifier for `getDisplayName()` indicating a long name, such as "Pacific Standard Time."
    `static int` | `SHORT` | A style specifier for `getDisplayName()` indicating a short name, such as "PST."

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TimeZone()` | Sole constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Object` | `clone()` | Creates a copy of this `TimeZone`.
    `static String[]` | `getAvailableIDs()` | Gets all the available IDs supported.
    `static TimeZone` | `getDefault()` | Gets the default `TimeZone` for this host.
    `int` | `getDSTSavings()` | Returns the amount of time to be added to local standard time to get local wall clock time.
    `String` | `getID()` | Gets the ID of this time zone.
    `abstract int` | `getOffset​(int era, int year, int month, int day, int dayOfWeek, int milliseconds)` | Gets the time zone offset, for current date, modified in case of daylight savings.
    `int` | `getOffset​(long date)` | Returns the offset of this time zone from UTC at the specified date.
    `abstract int` | `getRawOffset()` | Returns the amount of time in milliseconds to add to UTC to get standard time in this time zone.
    `static TimeZone` | `getTimeZone​(String ID)` | Gets the `TimeZone` for the given ID.
    `boolean` | `hasSameRules​(TimeZone other)` | Returns true if this zone has the same rule and offset as another zone.
    `void` | `setID​(String ID)` | Sets the time zone ID.
    `abstract boolean` | `useDaylightTime()` | Queries if this `TimeZone` uses Daylight Saving Time.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### LONG

          public static final int LONG

      A style specifier for `getDisplayName()` indicating a long name, such as "Pacific Standard Time."
      See Also:
        `SHORT`, Constant Field Values

    - #### SHORT

          public static final int SHORT

      A style specifier for `getDisplayName()` indicating a short name, such as "PST."
      See Also:
        `LONG`, Constant Field Values

  - ### Constructor Detail

    - #### TimeZone

          public TimeZone()

      Sole constructor. (For invocation by subclass constructors, typically implicit.)

  - ### Method Detail

    - #### getAvailableIDs

          public static String[] getAvailableIDs()

      Gets all the available IDs supported.
      Returns:
        an array of IDs.

    - #### getDefault

          public static TimeZone getDefault()

      Gets the default `TimeZone` for this host. The source of the default `TimeZone` may vary with implementation.
      Returns:
        a default `TimeZone`.

    - #### getTimeZone

          public static TimeZone getTimeZone​(String ID)

      Gets the `TimeZone` for the given ID.
      Parameters:
        `ID` - the ID for a `TimeZone`, either an abbreviation such as "PST", a full name such as "America/Los_Angeles", or a custom ID such as "GMT-8:00".
      Returns:
        the specified `TimeZone`, or the GMT zone if the given ID cannot be understood.

    - #### clone

          public Object clone()

      Creates a copy of this `TimeZone`.
      Overrides:
        `clone` in class `Object`
      Returns:
        a clone of this `TimeZone`
      See Also:
        `Cloneable`

    - #### getDSTSavings

          public int getDSTSavings()

      Returns the amount of time to be added to local standard time to get local wall clock time.

      The default implementation returns 3600000 milliseconds (i.e., one hour) if a call to `useDaylightTime()` returns `true`. Otherwise, 0 (zero) is returned.

      If an underlying `TimeZone` implementation subclass supports historical and future Daylight Saving Time schedule changes, this method returns the amount of saving time of the last known Daylight Saving Time rule that can be a future prediction.

      If the amount of saving time at any given time stamp is required, construct a `Calendar` with this `TimeZone` and the time stamp, and call `Calendar.get``(``Calendar.DST_OFFSET``)`.

      Returns:
        the amount of saving time in milliseconds
      See Also:
        `getOffset(long)`, `getOffset(int,int,int,int,int,int)`, `Calendar.ZONE_OFFSET`

    - #### getID

          public String getID()

      Gets the ID of this time zone.
      Returns:
        the ID of this time zone.

    - #### getOffset

          public abstract int getOffset​(int era,
                                        int year,
                                        int month,
                                        int day,
                                        int dayOfWeek,
                                        int milliseconds)

      Gets the time zone offset, for current date, modified in case of daylight savings. This is the offset to add to UTC to get local time.

      This method returns a historically correct offset if an underlying `TimeZone` implementation subclass supports historical Daylight Saving Time schedule and GMT offset changes.

      Parameters:
        `era` - the era of the given date.
        `year` - the year in the given date.
        `month` - the month in the given date. Month is 0-based. e.g., 0 for January.
        `day` - the day-in-month of the given date.
        `dayOfWeek` - the day-of-week of the given date.
        `milliseconds` - the milliseconds in day in standard local time.
      Returns:
        the offset in milliseconds to add to GMT to get local time.
      See Also:
        `Calendar.ZONE_OFFSET`, `Calendar.DST_OFFSET`

    - #### getOffset

          public int getOffset​(long date)

      Returns the offset of this time zone from UTC at the specified date. If Daylight Saving Time is in effect at the specified date, the offset value is adjusted with the amount of daylight saving.

      This method returns a historically correct offset value if an underlying TimeZone implementation subclass supports historical Daylight Saving Time schedule and GMT offset changes.

      Parameters:
        `date` - the date represented in milliseconds since January 1, 1970 00:00:00 GMT
      Returns:
        the amount of time in milliseconds to add to UTC to get local time.
      See Also:
        `Calendar.ZONE_OFFSET`, `Calendar.DST_OFFSET`

    - #### getRawOffset

          public abstract int getRawOffset()

      Returns the amount of time in milliseconds to add to UTC to get standard time in this time zone. Because this value is not affected by daylight saving time, it is called raw offset.

      If an underlying `TimeZone` implementation subclass supports historical GMT offset changes, the method returns the raw offset value of the current date. In Honolulu, for example, its raw offset changed from GMT-10:30 to GMT-10:00 in 1947, and this method always returns -36000000 milliseconds (i.e., -10 hours).

      Returns:
        the amount of raw offset time in milliseconds to add to UTC.
      See Also:
        `Calendar.ZONE_OFFSET`

    - #### hasSameRules

          public boolean hasSameRules​(@Nullable
                                      TimeZone other)

      Returns true if this zone has the same rule and offset as another zone. That is, if this zone differs only in ID, if at all. Returns false if the other zone is null.
      Parameters:
        `other` - the `TimeZone` object to be compared with
      Returns:
        true if the other zone is not null and is the same as this one, with the possible exception of the ID

    - #### setID

          public void setID​(String ID)

      Sets the time zone ID. This does not change any other data in the time zone object.
      Parameters:
        `ID` - the new time zone ID.

    - #### useDaylightTime

          public abstract boolean useDaylightTime()

      Queries if this `TimeZone` uses Daylight Saving Time.

      If an underlying `TimeZone` implementation subclass supports historical and future Daylight Saving Time schedule changes, this method refers to the last known Daylight Saving Time rule that can be a future prediction and may not be the same as the current rule.

      Returns:
        `true` if this `TimeZone` uses Daylight Saving Time, `false`, otherwise.
      See Also:
        `Calendar.DST_OFFSET`